﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;
using System.Collections;
using UnityEngine.UI;

public class CollisionDetector : NetworkBehaviour {

	[SyncVar]
	public bool hasDisease = false;
	bool isActivated;
	bool isSwapping;
	public bool speedEnabled;
	public bool isImmune;

	public GameObject[] rendObj;

	public GameObject hands;
	public GameObject skinHandsL;
	public GameObject skinHandsR;

	Renderer rend;

	PlayerController _pC;

	Color originalColour;
	int originalSpeed;
	public int speedWithDisease;

	[ClientRpc]
	public void RpcSwitchDisease()
	{
		hasDisease = !hasDisease;
	}


	void Start()
	{
			_pC = this.gameObject.GetComponent<PlayerController> ();
			originalSpeed = _pC.playerSpeed;
	}


	void OnTriggerEnter(Collider collision)
	{

		if (collision.gameObject.name.Contains ("Player") && !isSwapping){
			var hit = collision.gameObject;
			var health = hit.GetComponent<Health> ();
			StartCoroutine (WaitToSwitch ());
		}


	}

	public IEnumerator WaitToSwitch()
	{
		isSwapping = true;
		RpcSwitchDisease ();
		yield return new WaitForSeconds (2.5f);
		isSwapping = false;
	}

	void FixedUpdate(){

		if (hasDisease) {
			hands.SetActive (true);
			skinHandsL.SetActive (false);
			skinHandsR.SetActive (false);
			_pC.playerSpeed = speedWithDisease;
			foreach (GameObject Tform in rendObj) {
				Tform.GetComponent<Renderer>().material.SetColor ("_Color", new Color32(0, 133, 76, 1));
			}

		}
		if(!hasDisease){
			hands.SetActive (false);
			skinHandsL.SetActive (true);
			skinHandsR.SetActive (true);
			_pC.playerSpeed = originalSpeed;
			foreach (GameObject Tform in rendObj) {
				Tform.GetComponent<Renderer>().material.SetColor ("_Color", new Color32(237, 138, 89, 1));
			}
		}

		if (hasDisease && !isActivated && !isImmune) {
			IncrementDamage ();
		}

	}

	public void IncrementDamage()
	{
		isActivated = true;
		StartCoroutine (WaitToTakeDamage());
	}

	public IEnumerator WaitToTakeDamage()
	{
		this.GetComponent<Health> ().TakeDamage (1);
		yield return new WaitForSeconds (1.0f);
		isActivated = false;

	}

}