﻿using UnityEngine;
using System.Collections;
using UnityEngine.Networking;

public class CollisionDetector2 : NetworkBehaviour {

	public bool hasDisease;
	bool isActivated;

	void Start()
	{
		if (isServer) {
			hasDisease = true;
		}
	}

	void OnCollisionEnter(Collision collision)
	{
		if (collision.gameObject.name.Contains("Player")) {
			var hit = collision.gameObject;
			var health = hit.GetComponent<Health> ();
			//		if (health  != null)
			//		{

			hasDisease = !hasDisease;
		}
	}

	void Update(){
		if (hasDisease && !isActivated) {
			IncrementDamage ();
		}

	}

	public void IncrementDamage()
	{
		isActivated = true;
		StartCoroutine (WaitToTakeDamage());
	}

	public IEnumerator WaitToTakeDamage()
	{
		this.GetComponent<Health> ().TakeDamage (1);
		yield return new WaitForSeconds (1.0f);
		isActivated = false;

	}

}
//}