﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using UnityEngine.Networking;

public class Health : NetworkBehaviour {

	public const int maxHealth = 25;
	public Animator playerAnim;
	public GameObject playerObject;

	[SyncVar(hook = "OnChangeHealth")]
	public int currentHealth = maxHealth;

	public RectTransform healthBar;

	PlayerController _pC;
	CollisionDetector _cD;
	PlayerCounter _pCounter;

	[SyncVar]
	public bool isDead = false;


	[ClientRpc]
	public void RpcIsDead()
	{
		isDead = true;
		_pCounter.RemovePlayerFromList ();
	}

	void Start()
	{
		playerAnim = playerObject.GetComponent<Animator> ();
		currentHealth = 25;
		_pC = this.gameObject.GetComponent<PlayerController> ();
		_pCounter = GameObject.FindGameObjectWithTag ("PlayerCounter").GetComponent<PlayerCounter>();
		_cD = this.GetComponent<CollisionDetector>();
//		healthBar = GetComponentInChildren<
//			GameObject.Find("Foreground").GetComponent<RectTransform>();
	}

	public void TakeDamage(int amount)
	{

		currentHealth -= amount;
		if (currentHealth <= 0 && !isDead)
		{
			_pCounter.RemovePlayerFromList ();
			currentHealth = 0;
			RpcIsDead ();
			_cD.hands.SetActive (false);
//			playerAnim.SetBool ("playerIsWalking", false);
//			playerAnim.SetBool ("playerIsWalkingBackwards", false);
//			playerAnim.SetBool ("playerIsDead", true);
		}
	}

	void OnChangeHealth (int currentHealth)
	{
		healthBar.sizeDelta = new Vector2(currentHealth, healthBar.sizeDelta.y);
	}
}