﻿#if ENABLE_UNET


namespace UnityEngine.Networking

{

	[AddComponentMenu("Network/NetworkManagerHUD")]

	[RequireComponent(typeof(NetworkManager))]

	[System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never)]

	public class NewNetworkManagerUI : MonoBehaviour

	{

		public GUIStyle myStyle;


		public NetworkManager manager;

		[SerializeField] public bool showGUI = true;

		[SerializeField] public int offsetX;

		[SerializeField] public int offsetY;

		public GUIStyle myLabelStyle;
		public GUIStyle myBoxStyle;

		// Runtime variable

		bool showServer = false;


		void Awake()

		{

			manager = GetComponent<NetworkManager>();

		}


		void Update()

		{

			if (!showGUI)

				return;


			if (!NetworkClient.active && !NetworkServer.active && manager.matchMaker == null)

			{

				if (Input.GetKeyDown(KeyCode.S))

				{

					manager.StartServer();

				}

				if (Input.GetKeyDown(KeyCode.H))

				{

					manager.StartHost();

				}

				if (Input.GetKeyDown(KeyCode.C))

				{

					manager.StartClient();

				}

			}

			if (NetworkServer.active && NetworkClient.active)

			{

				if (Input.GetKeyDown(KeyCode.X))

				{

					manager.StopHost();

				}

			}

		}


		void OnGUI()

		{

			if (!showGUI)

				return;

			int xpos = 10 + offsetX;

			int ypos = 40 + offsetY;

			int spacing = 50;



			if (!NetworkClient.active && !NetworkServer.active && manager.matchMaker == null)

			{
				GUI.Box( new Rect(283, 50, 450, 450 ), "", myBoxStyle );
				
				GUI.skin.label = myLabelStyle;
				
				GUI.Label(new Rect(xpos+266, ypos, 350, 50), "Tell People Your IP = " + Network.player.ipAddress);

				ypos += spacing;

	
				GUI.Label(new Rect(xpos+266, ypos, 350, 50), "AND");


				ypos += spacing;
				

				if (GUI.Button(new Rect(xpos+378, ypos, 125, 50), "HOST GAME", myStyle))

				{

					manager.StartHost();

				}

				ypos += spacing;


				GUI.Label(new Rect(xpos+266, ypos, 350, 50), "OR");

				ypos += spacing;

				GUI.Label(new Rect(xpos+269, ypos, 350, 50), "TYPE IP HERE:");

				ypos += spacing;

				GUI.skin.textField = myStyle;

				manager.networkAddress = GUI.TextField(new Rect(xpos+235, ypos, 400, 50), manager.networkAddress);

				ypos += spacing;

				GUI.Label(new Rect(xpos+269, ypos, 350, 50), "AND");

				ypos += spacing;

				if (GUI.Button(new Rect(xpos+375, ypos, 125, 50), "JOIN GAME", myStyle))

				{

					manager.StartClient();

				}



				ypos += spacing;



			}

			else

			{

				if (NetworkServer.active)

				{

				}

				if (NetworkClient.active)

				{

					//GUI.Label(new Rect(xpos, ypos, 300, 20), "Client: address=" + manager.networkAddress + " port=" + manager.networkPort, myStyle);

					ypos += spacing;

				}

			}




//			if (NetworkClient.active && !ClientScene.ready)
//
//			{
//
//				if (GUI.Button(new Rect(xpos, ypos, 200, 20), "Client Ready", myStyle))
//
//				{
//
//					ClientScene.Ready(manager.client.connection);
//
//
//
//					if (ClientScene.localPlayers.Count == 0)
//
//					{
//
//						ClientScene.AddPlayer(0);
//
//					}
//
//				}
//
//				ypos += spacing;
//
//			}




			if (NetworkServer.active || NetworkClient.active)

			{

				if (GUI.Button(new Rect(xpos-30, ypos-70, 125, 50), "QUIT", myStyle))

				{

					manager.StopHost();

				}

				ypos += spacing;

			}




			if (!NetworkServer.active && !NetworkClient.active)

			{

				ypos += 10;




				if (manager.matchMaker == null)

				{

//					if (GUI.Button(new Rect(xpos, ypos, 200, 20), "Enable Match Maker (M)"))
//
//					{
//
//						manager.StartMatchMaker();
//
//					}
//
//					ypos += spacing;

				}



			}

		}

	}

};

#endif //ENABLE_UNET