﻿using UnityEngine;
using UnityEngine.Networking;
using System.Collections;

public class PlayerController : NetworkBehaviour
{
	public GameObject buildablePrefab;
	public Transform itemSpawn;

	public int playerSpeed;
	public int playerTurnSpeed;

	public int destroyTime;
	public float waitTimer;

	public bool shootTimer;

	public GameObject playerObject;
	public Animator playerAnim;
	public Animator graveAnim;
	public GameObject graveAnimInner;

	public bool canFire;
	public bool isSpeedy;
	public bool isSlowed;

	public GameObject gravestone;

	CollisionDetector CD;

	public int speedUpAmount = 20;
	public int slowDownAmount = 7;

	Health _health;

	[ClientRpc]
	public void RpcSetAnims()
	{	
		
	}


	void Start()
	{
		playerAnim = playerObject.GetComponent<Animator> ();
		graveAnim = graveAnimInner.GetComponent<Animator> ();
		_health = this.GetComponent <Health> ();
		CD = this.GetComponent <CollisionDetector> ();
		isSpeedy = false;
		isSlowed = false;
		gravestone.SetActive (false);

	}

	void Update()
	{
		if (!isLocalPlayer)
		{
			return;
		}
//MovementCode
		if (Input.GetAxis ("Vertical") > 0 && !_health.isDead) 
		{
			waitTimer = 0.2f;
			playerAnim.SetBool ("playerIsWalking", true);
			playerAnim.SetBool ("playerIsWalkingBackwards", false);
		} else if (Input.GetAxis ("Vertical") < 0) {
			waitTimer = 0.2f;
			playerAnim.SetBool ("playerIsWalking", false);
			playerAnim.SetBool ("playerIsWalkingBackwards", true);
		} else {
			waitTimer = 5.0f;
			playerAnim.SetBool ("playerIsWalking", false);
			playerAnim.SetBool ("playerIsWalkingBackwards", false);
		}

		if (_health.isDead) {
			//playerAnim.SetBool ("playerIsDead", true);
			CD.hands.SetActive (false);
			gravestone.SetActive (true);

			//graveAnim.SetBool ("playerIsDeadRip", true);

		}

		var x = Input.GetAxis("Horizontal") * Time.deltaTime * playerTurnSpeed;

		transform.Rotate(0, x, 0);

		if (!isSpeedy && !isSlowed && _health.currentHealth > 0) {
			var z = Input.GetAxis ("Vertical") * Time.deltaTime * playerSpeed;
			transform.Translate (0, 0, z);

		} else if (isSpeedy && !isSlowed && _health.currentHealth > 0) {
			var z = Input.GetAxis ("Vertical") * Time.deltaTime * speedUpAmount;
			transform.Translate (0, 0, z);

		} else if (isSlowed && _health.currentHealth > 0) {
			var z = Input.GetAxis ("Vertical") * Time.deltaTime * slowDownAmount;
			transform.Translate (0, 0, z);

		}


		if (Input.GetKeyDown(KeyCode.Space) && !shootTimer && canFire)
		{
			CmdFire();
			shootTimer = true;
			StartCoroutine (ShootWaiter ());
		}
	}

	// This [Command] code is called on the Client …
	// … but it is run on the Server!
	[Command]
	void CmdFire()
	{
		// Create the Bullet from the Bullet Prefab
		var buildableItem = (GameObject)Instantiate(
			buildablePrefab,
			itemSpawn.position,
			itemSpawn.rotation);

		// Add velocity to the bullet
		buildableItem.GetComponent<Rigidbody>().velocity = buildableItem.transform.forward * 0.1f;

		// Spawn the bullet on the Clients
		NetworkServer.Spawn(buildableItem);

		// Destroy the bullet after 2 seconds
		Destroy(buildableItem, destroyTime);
	}

	public override void OnStartLocalPlayer ()
	{
		GetComponent<MeshRenderer>().material.color = Color.blue;
	}

	IEnumerator ShootWaiter(){
		yield return new WaitForSeconds (waitTimer);
		shootTimer = false;

	}
}