﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Networking;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class PlayerCounter : NetworkBehaviour {

	public Text gameOverText;

	bool notAlone = false;
	bool gameStarted = false;

	public GameObject[] players;
	[SyncVar]
	public int numberOfPlayers;

	NewNetworkManagerUI _nNMUI;

	[ClientRpc]
	public void RpcSetPlayersAmount()
	{	
		numberOfPlayers = players.Length+1;
		print ("Set Player Amnt to: " + numberOfPlayers);
	}
		
	public void RemovePlayerFromList()
	{
		numberOfPlayers -= 1;
	}

	void Start()
	{
		_nNMUI = GameObject.FindGameObjectWithTag ("NetworkManager").GetComponent<NewNetworkManagerUI> ();
		InvokeRepeating ("CheckForNewPlayers", 1, 1);
		notAlone = false;
		gameStarted = false;
		numberOfPlayers = players.Length+1;
		gameOverText = GameObject.FindGameObjectWithTag ("GameOverText").GetComponent<Text>();
		gameOverText.text = "";
		players = GameObject.FindGameObjectsWithTag ("Player");
		RpcSetPlayersAmount ();
	}


	void FixedUpdate()
	{
		
		print (numberOfPlayers);
		players = GameObject.FindGameObjectsWithTag ("Player");
		
		if(numberOfPlayers>=2){
			notAlone = true;
		}

		if (notAlone && !gameStarted) {
			int index = Random.Range (0, 1);
			GameObject chosenPoint = players [index];
			players [index].gameObject.GetComponent<CollisionDetector> ().hasDisease = true;
			gameStarted = true;
		}

		if (numberOfPlayers <= 1 && notAlone) {
			GameOver ();
		}

	}
		
	public void CheckForNewPlayers()
	{
		numberOfPlayers = players.Length;
	}

	public void GameOver()
	{
		gameOverText.text = "GAME OVER";
		print ("GAME OVER SUCKAS");
		StartCoroutine(WaitToEnd ());
	} 

	public IEnumerator WaitToEnd()
	{
		yield return new WaitForSeconds (5);
		gameOverText.text = "";
		_nNMUI.manager.StopHost();
		_nNMUI.showGUI = false;
		SceneManager.LoadScene( "MenuScene", LoadSceneMode.Single );
	}

	public void StopHostOnButton(){
		
		_nNMUI.showGUI = true;
	}

}
